(function() {
  'use strict';

  angular
    .module('oembedkit', [])
    .controller('oembedkitController', loadFunction);

  loadFunction.$inject = ['$scope', 'structureService', '$location', 'oembedAPI'];

  function loadFunction($scope, structureService, $location, oembedAPI) {
    // Register upper level modules
    structureService.registerModule($location, $scope, 'oembedkit');

    var urlapi = $scope.oembedkit.modulescope.APIurl;
    var url = $scope.oembedkit.modulescope.url;

    oembedAPI.getJson(urlapi, url).then(saveData, errorLog);


    function saveData(data) {
      var firstfix = replaceAll(data.html, "https://", "//");
      var final = replaceAll(firstfix, "//", "https://");
      $scope.html = final;
      console.log($scope.html);
    }

    function errorLog(error) {
      console.log("Error ->", error);
    }

    function replaceAll(html, str, replace) {
      return html.split(str).join(replace);
    }
  }
}());
